-- SwitchTarget written by Denji 'diqrtvpe' Royhu
-- With many thanks to Mick, Miharu, slime, FiReMaGe, BlackNet, Mor Isil, and others for lua help.

declare('SwitchTarget', {})

SwitchTarget.version = '\127ffffffVersion 1.3'
SwitchTarget.help1 = '\127ffffffTo turn SwitchTarget on and off, use \'/switchtarget\'. To switch targets, use \'/target\'. To toggle between leader/follower and multi-target, use \'/leader\', and to see your mode, use \'/stmode\'.'
SwitchTarget.help2 = '\127ffffffThe group leader starts out as the target leader. To switch leaders, use \'/leaderswitch "name"\', or \'/stls "name"\'.'
SwitchTarget.help3 = '\127ffffffIf you are the group target leader, you can set everyone in the group to leader mode with \'/leaderall\', or \'/stla\'.'
SwitchTarget.help4 = '\127ffffffTo switch targets to an asteroid or cargo crate, use \'/targetroid\', or \'/rtarget\'. To join or switch to a subgroup, use \'/subgroup #\', or \'/stsg #\'. Leave a subgroup with just \'/subgroup\'.'
SwitchTarget.active = false
SwitchTarget.leader = false
SwitchTarget.group = false
SwitchTarget.sub = '0'

local chatreceiver_old = chatreceiver.OnEvent

function chatreceiver:OnEvent(event, data)
-- Initial login stuff to do.
	if event == "LOGIN_SUCCESSFUL" then
		ClearGeneralChatLog()
		ClearMissionChatLog()
		ClearStationChatLog()
		_generalchatlog = GetGeneralChatLog()
		_missionlog = GetMissionChatLog()
		_stationlog = GetStationChatLog()
		GeneralChatPanel = {log=_generalchatlog}
		MissionLogPanel = {log=_missionlog}
		StationLogPanel = {log=_stationlog}
	else
	-- Set up the variables we will be using; the commands are activated by specific strings in (), {}, and [], and will not be passed into the chat box while the plugin is active.
		local sg = string.match(data.msg, '(%<.-%>)')
		local ld = string.match(data.msg, '(%[.-%])')
		local nd = string.match(data.msg, '(%(.-%))')
		local ob = string.match(data.msg, '(%{.-%})')
		--In multi-target mode, switch targets when any group member commands.
		if nd and ob ~= nil and data.location == GetCurrentSectorid() and SwitchTarget.group == false and SwitchTarget.leader == false and SwitchTarget.active == true then
			local node = string.match(nd, '(%d+)')
			local obj = string.match(ob, '(%d+)')
			local sender = data.name
			if SwitchTarget.sub == '0' then
				if event == 'CHAT_MSG_GROUP' and data.location == GetCurrentSectorid() and not PlayerInStation() then
					radar.SetRadarSelection(node, obj)
					local name = GetTargetInfo()
					print(chatinfo.CHAT_MSG_GROUP[1] .. sender..' switched target to '..name)
				else chatreceiver_old(chatreceiver, event, data)
				end
			elseif sg ~= nil then
				local sub = string.match(sg, '(%d+)')
				if event == 'CHAT_MSG_GROUP' and sub == SwitchTarget.sub and data.location == GetCurrentSectorid() and not PlayerInStation() then
					radar.SetRadarSelection(node, obj)
					local name = GetTargetInfo()
					print(chatinfo.CHAT_MSG_GROUP[1] .. sender..' switched target to '..name)
				else chatreceiver_old(chatreceiver, event, data)
				end
			end
		--In follower target mode, switch targets when the target leader commands.
		elseif ld and nd and ob ~= nil and SwitchTarget.group == true and SwitchTarget.leader == false and SwitchTarget.active == true then
			local node = string.match(nd, '(%d+)')
			local obj = string.match(ob, '(%d+)')
			local sender = data.name
			local leader = string.match(ld, '([%d%a]+)')
			if SwitchTarget.sub == '0' then
				if event == 'CHAT_MSG_GROUP' and data.location == GetCurrentSectorid() and not PlayerInStation() and leader == '1' then
					radar.SetRadarSelection(node, obj)
					local name = GetTargetInfo()
					print(chatinfo.CHAT_MSG_GROUP[1] .. sender..' switched target to '..name)
				else chatreceiver_old(chatreceiver, event, data)
				end
			elseif sg ~= nil then
				local sub = string.match(sg, '(%d+)')
				if event == 'CHAT_MSG_GROUP' and sub == SwitchTarget.sub and data.location == GetCurrentSectorid() and not PlayerInStation() and leader == '1' then
					radar.SetRadarSelection(node, obj)
					local name = GetTargetInfo()
					print(chatinfo.CHAT_MSG_GROUP[1] .. sender..' switched target to '..name)
				else chatreceiver_old(chatreceiver, event, data)
				end
			end
		--In leader target mode, don't pass the target command.
		elseif ld and nd and ob ~= nil and SwitchTarget.group == false and SwitchTarget.leader == true and SwitchTarget.active == true then
			local node = string.match(nd, '(%d+)')
			local obj = string.match(ob, '(%d+)')
			local leader = string.match(ld, '(%d+)')
			if SwitchTarget.sub == '0' then
				if event == 'CHAT_MSG_GROUP' and data.location == GetCurrentSectorid() and not PlayerInStation() and leader == '1' then
					local name = GetTargetInfo()
					print(chatinfo.CHAT_MSG_GROUP[1] .. 'Target Switched to '..name)
				else chatreceiver_old(chatreceiver, event, data)
				end
			elseif sg ~= nil then
				local sub = string.match(sg, '(%d+)')
				if event == 'CHAT_MSG_GROUP' and sub == SwitchTarget.sub and data.location == GetCurrentSectorid() and not PlayerInStation() and leader == '1' then
					local name = GetTargetInfo()
					print(chatinfo.CHAT_MSG_GROUP[1] .. 'Target switched to '..name)
				else chatreceiver_old(chatreceiver, event, data)
				end
			end
		--In follower target mode, switch target leader on command from previous target leader.
		elseif ld and nd ~= nil and ob == nil and SwitchTarget.active == true and (SwitchTarget.group or SwitchTarget.leader) == true then
			local node = string.match(nd, '([%a%s]+)')
			local leader = string.match(ld, '(%a+)')
			local name = node
			if leader == 'switch' then
				if SwitchTarget.sub == '0' then
					if GetCharacterIDByName(name) == GetCharacterID() then
						SwitchTarget.group = false
						SwitchTarget.leader = true
						print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are now the group target leader.')
					else
						print(chatinfo.CHAT_MSG_GROUP[1] .. name..' is the new group target leader.')
					end
				elseif sg ~= nil then
					local sub = string.match(sg, '(%d+)')
					if sub == SwitchTarget.sub then
						if GetCharacterIDByName(name) == GetCharacterID() then
							SwitchTarget.group = false
							SwitchTarget.leader = true
							print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are now the group target leader.')
						else
							print(chatinfo.CHAT_MSG_GROUP[1] .. name..' is the new group target leader.')
						end
					else chatreceiver_old(chatreceiver, event, data)
					end
				end
			end
		--In multi target mode, turns on follower target mode at command from group target leader.
		elseif ld and nd ~= nil and ob == nil and SwitchTarget.active == true and (SwitchTarget.group and SwitchTarget.leader) == false then
			local leader = string.match(ld, '(%a+)')
			if leader == 'setall' then
				if SwitchTarget.sub == '0' or sub == SwitchTarget.sub then
					SwitchTarget.group = true
					print(chatinfo.CHAT_MSG_GROUP[1] .. 'Target mode now set to follow leader.')
				end
			end
		--If you're not in the sector, someone calling a target switch sets your navroute to the sector they're in.
		elseif nd and ob ~= nil and SwitchTarget.active == true and data.location ~= GetCurrentSectorid() then
			if SwitchTarget.sub == '0' or sub == SwitchTarget.sub then
				NavRoute.clear()
				NavRoute.add(ShortLocationStr(data.location))
				chatreceiver_old(chatreceiver, event, data)
			elseif sg ~= nil then
				local sub = string.match(sg, '(%d+)')
				NavRoute.clear()
				NavRoute.add(ShortLocationStr(data.location))
				chatreceiver_old(chatreceiver, event, data)
			end
		--Passes chat back to the regular chatreceiver.
		else
			chatreceiver_old(chatreceiver, event, data)
		end
	end
end

-- Toggle follower target mode (leader target mode if you are the Group Leader).
function SwitchTarget.leader()
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	elseif SwitchTarget.sub == '0' then
		if SwitchTarget.group == false and SwitchTarget.leader == false then
			if GetCharacterID() == GetGroupOwnerID() then
				SwitchTarget.group = false
				SwitchTarget.leader = true
				print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are now the group target leader.')
			else
				SwitchTarget.leader = false
				SwitchTarget.group = true
				print(chatinfo.CHAT_MSG_GROUP[1] .. 'Your targets are now following the group leader.')
			end
		elseif SwitchTarget.group or SwitchTarget.leader == true then
			SwitchTarget.group = false
			SwitchTarget.leader = false
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are now in multi-target mode.')
		end
	end
end

-- Tells you which mode you're in.
function SwitchTarget.mode()
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	elseif SwitchTarget.sub == '0' then
		if SwitchTarget.group == false and SwitchTarget.leader == false then
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are in multi-target mode.')
		elseif SwitchTarget.group == true and SwitchTarget.leader == false then
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are in follower mode.')
		elseif SwitchTarget.group == false and SwitchTarget.leader == true then
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'You are in leader mode.')
		end
	end
end

-- Give a switch leader command in leader mode.
function SwitchTarget.leaderswitch(_,data)
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	elseif SwitchTarget.sub == '0' then
		if data[1] == nil then
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Please specify a player to become the group target leader')
		else
			local name = data[1]
			if IsGroupMember(GetCharacterIDByName(name)) == false then
				print(chatinfo.CHAT_MSG_GROUP[1] .. 'That player is not in the group, please choose a group member.')
			else
				SwitchTarget.leader = false
				SwitchTarget.group = true
				SendChat('[switch]('..name..')', 'GROUP')
			end
		end
	end
end

-- Make everyone switch to leader mode, if you're the group target leader.
function SwitchTarget.leaderall()
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	elseif SwitchTarget.sub == '0' then
		if SwitchTarget.leader == false then
			print('You must be group target leader to set group to leader.')
		else
			SendChat('[setall](0)', 'GROUP')
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Group targets now following leader.')
		end
	end
end
		

function SwitchTarget.cmd(_,data)
	if not data then
		-- Turn the plugin on and off.
		if SwitchTarget.active == false then
			SwitchTarget.active = true
			SwitchTarget.group = false
			SwitchTarget.leader = false
			print('\127ffffffSwitchtarget ON')
		else
			SwitchTarget.active = false
			print('\127ffffffSwitchtarget OFF')
		end
	elseif string.lower(data[1]) == 'help' then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	else
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	end
end

function SwitchTarget.target()
	print(SwitchTarget.sub)
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	-- Give a switch target command in multi-target mode.
	elseif SwitchTarget.active == true and SwitchTarget.leader == false and SwitchTarget.group == false and SwitchTarget.sub == '0' then
		if radar.GetRadarSelectionID() ~= 2 then
			if GetTargetInfo() ~= nil then
				local a,b = radar.GetRadarSelectionID()
				local name, health, distance, factionid, guild, ship = GetTargetInfo()
				SendChat('('..a..'){'..b..'} Current target: '..name..', piloting '..Article(ship)..' with '.. math.floor(GetPlayerHealth(GetCharacterIDByName(name))) ..'% armor.', 'GROUP')
			end
		end
	-- Attempt to give a switch target command in follower mode (fails).
	elseif SwitchTarget.active == true and SwitchTarget.leader == false and SwitchTarget.group == true then
		print(chatinfo.CHAT_MSG_GROUP[1] .. 'Target NOT Switched -- You are not group target leader')
	-- Give a switch target command in leader mode.
	elseif SwitchTarget.active == true and SwitchTarget.leader == true and SwitchTarget.group == false and SwitchTarget.sub == '0' then
		if radar.GetRadarSelectionID() ~= 2 then
			if GetTargetInfo() ~= nil then
				local a,b = radar.GetRadarSelectionID()
				local name, health, distance, factionid, guild, ship = GetTargetInfo()
				SendChat('[1]('..a..'){'..b..'} Current target: '..name..', piloting '..Article(ship)..' with '.. math.floor(GetPlayerHealth(GetCharacterIDByName(name))) ..'% armor.', 'GROUP')
			end
		end
	-- Give a switch target command in subgroup multi-target mode.
	elseif SwitchTarget.active == true and SwitchTarget.leader == false and SwitchTarget.group == false and string.match(SwitchTarget.sub, '([1-9])') then
		if radar.GetRadarSelectionID() ~= 2 then
			if GetTargetInfo() ~= nil then
				local a,b = radar.GetRadarSelectionID()
				local name, health, distance, factionid, guild, ship = GetTargetInfo()
				local subgroup = SwitchTarget.sub
				SendChat('<'..subgroup..'>('..a..'){'..b..'} Current target: '..name..', piloting '..Article(ship)..' with '.. math.floor(GetPlayerHealth(GetCharacterIDByName(name))) ..'% armor.', 'GROUP')
			end
		end
	-- Give a switch target command in subgroup leader mode.
	elseif SwitchTarget.active == true and SwitchTarget.leader == true and SwitchTarget.group == false and string.match(SwitchTarget.sub, '([1-9])') then
		if radar.GetRadarSelectionID() ~= 2 then
			if GetTargetInfo() ~= nil then
				local a,b = radar.GetRadarSelectionID()
				local name, health, distance, factionid, guild, ship = GetTargetInfo()
				local subgroup = SwitchTarget.sub
				SendChat('<'..subgroup..'>[1]('..a..'){'..b..'} Current target: '..name..', piloting '..Article(ship)..' with '.. math.floor(GetPlayerHealth(GetCharacterIDByName(name))) ..'% armor.', 'GROUP')
			end
		end
	end
end

-- Let's you give switch target commands for roids or cargo.
function SwitchTarget.roid()
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	-- Give a switch target command in multi-target mode.
	elseif SwitchTarget.active == true and SwitchTarget.leader == false and SwitchTarget.group == false then
		if SwitchTarget.sub == '0' then
			if radar.GetRadarSelectionID() == 2 then
				if GetTargetInfo() ~= nil then
					local a,b = radar.GetRadarSelectionID()
					local name = GetTargetInfo()
					SendChat('('..a..'){'..b..'} Current target: '..name, 'GROUP')
				end
			end
		else
			local subgroup = SwitchTarget.sub
			if radar.GetRadarSelectionID() == 2 then
				if GetTargetInfo() ~= nil then
					local a,b = radar.GetRadarSelectionID()
					local name = GetTargetInfo()
					SendChat('<'..subgroup..'>('..a..'){'..b..'} Current target: '..name, 'GROUP')
				end
			end
		end
	-- Attempt to give a switch target command in follower mode (fails).
	elseif SwitchTarget.active == true and SwitchTarget.leader == false and SwitchTarget.group == true and SwitchTarget.sub == '0' then
		print(chatinfo.CHAT_MSG_GROUP[1] .. 'Target NOT Switched -- You are not group target leader')
	-- Give a switch target command in leader mode.
	elseif SwitchTarget.active == true and SwitchTarget.leader == true and SwitchTarget.group == false and SwitchTarget.sub == '0' then
		if radar.GetRadarSelectionID() == 2 then
			if GetTargetInfo() ~= nil then
				local a,b = radar.GetRadarSelectionID()
				local name, health, distance, factionid, guild, ship = GetTargetInfo()
				SendChat('[1]('..a..'){'..b..'} Current target: '..name, 'GROUP')
			end
		end
	end
end

-- Sets up subgroups within your group.
function SwitchTarget.subgroup(_,data)
	if SwitchTarget.active == false then
		print(SwitchTarget.help1)
		print(SwitchTarget.help2)
		print(SwitchTarget.help3)
		print(SwitchTarget.help4)
		print(SwitchTarget.version)
	-- Turns subgrouping on (if no subgroup number is given, defaults to 1).
	elseif SwitchTarget.sub == '0' then
		if not data or data[1] == '1' then
			SwitchTarget.sub = '1'
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Now joining subgroup 1')
		elseif string.find(data[1], '([2-9])') then
			SwitchTarget.sub = data[1]
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Now joining subgroup '..data[1])
		else
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Not a valid subgroup, please choose a group between 1 and 9.')
		end
	else
		if not data then
			SwitchTarget.sub = '0'
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Now leaving subgroup.')
		elseif string.find(data[1], '([1-9])') then
			SwitchTarget.sub = data[1]
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Now joining subgroup '..data[1])
		else
			print(chatinfo.CHAT_MSG_GROUP[1] .. 'Not a valid subgroup, please choose a group between 1 and 9.')
		end
	end
end

RegisterUserCommand('switchtarget', SwitchTarget.cmd)
RegisterUserCommand('st', SwitchTarget.cmd)
RegisterUserCommand('leader', SwitchTarget.leader)
RegisterUserCommand('leaderswitch', SwitchTarget.leaderswitch)
RegisterUserCommand('stls', SwitchTarget.leaderswitch)
RegisterUserCommand('stmode', SwitchTarget.mode)
RegisterUserCommand('leaderall', SwitchTarget.leaderall)
RegisterUserCommand('stla', SwitchTarget.leaderall)
RegisterUserCommand('target', SwitchTarget.target)
RegisterUserCommand('targetroid', SwitchTarget.roid)
RegisterUserCommand('rtarget', SwitchTarget.roid)
RegisterUserCommand('subgroup', SwitchTarget.subgroup)
RegisterUserCommand('stsg', SwitchTarget.subgroup)